// original program version by Alastair, GW0AJU 
// see: https://sites.google.com/site/radiohamtechnology/arduino-qrp-beacon
//
// original program version was for converting serially incoming ASCII characters 
// for controlling DDS AD9850; output was CW Key signal on RF frequency
//
// Attached version has been modified and simplified by DJ7OO
// it only is using serially incoming ASCII characters for converting it 
// into morse key pulses available via #13

int ledPin = 13;           // outgoing key and morse indicator LED visual signal

char* letters[] = {".-","-...","-.-.","-..",".","..-.","--.","....","..",".---"
                    ,"-.-",".-..","--","-.","---",".--.","--.-",".-.","...","-"
                    ,"..-","...-",".--","-..-","-.--","--.."};                  

char* numbers[] = {"------",".----","..---","...--","....-",".....","-....",
                    "--...","---..","----."};
                    
// setting up speed variable 
int dotDelay = 50;           // I think is around 18 words per minute

//////////////////////////////////////////////////////////////////////
void setup()
          {
            pinMode(ledPin, OUTPUT);
            Serial.begin(9600);
            Serial.println(">>> ready for entering text sequences <<<");
          }

/////////////////////////////////////////////////////////////////////////////
// decoding the message characters typed in on the arduino IDE terminal monitor         
void flashSequence(char* sequence)
 {
   int i = 0; 
   while (sequence[i] != NULL )
   {
     flashDotOrDash(sequence[i]);
     i++;
   }
   delay(dotDelay * 3 );                                     // gap between letters
 }

//////////////////////////////////////////////////////////////////////
// sending out for transmission the appropriate morse characters
 void flashDotOrDash(char dotOrDash)
 {
   digitalWrite(ledPin, HIGH);                              // #13 = "HIGH" 
   if (dotOrDash == '.')
   {
     delay(dotDelay);
   }
   else                                                     // must be a -
   {
     delay(dotDelay * 3 );
   }
   digitalWrite(ledPin, LOW);                               // #13 = "LOW"      
   delay(dotDelay);                                         // gap between flashes
 }
 
/////////////////////////////////////////////////////////////////////////////////////// 
// Transmission porgram for morse code transmission via the terminal program
// used on the Arduino IDE, by typing in the TX message then 
// clicking send button on IDE terminal monitor
 void loop()
          {
            char ch;
            int em;
            if (Serial.available())
//  is there anything to be read from USB
            {
              ch = Serial.read();        // read a simple letter from terminal monitor of typed in TX message
              Serial.print(ch);          // back to IDE terminal monitor of TX message progress
              if (ch >= 'a' && ch <= 'z')
              {
                flashSequence(letters[ch - 'a']);
              }
            else if (ch >= 'A' && ch<= 'Z')
              {
                flashSequence(letters[ch - 'A']);
              }
            else if (ch >= '0' && ch <= '9' )
              {
                flashSequence(numbers[ch - '0']);
              }
            else if (ch == ' ')
              {
                delay(dotDelay * 4 );    // gap between words
              }
           }
        }
///////////////////////////////////////////////////////////////////////////////
